import { J as Json, O as ObjectStorage, L as LogHandlerOptions, d8 as LogMessage, a as LogHandler } from './uuid-86fe76bf.js';
export { dK as ArgumentsType, cC as AsyncMutex, cX as AsyncReturnType, _ as BinInput, d as CRYPTO_DEFAULT_ALG, e as CRYPTO_DEFAULT_DERIVE_ALG, f as CRYPTO_DEFAULT_DERIVE_ITERATIONS, C as CRYPTO_DEFAULT_HASH_ALG, di as Channel, dh as ChannelMessageEvent, dx as CryptoEncoder, ay as DAY_MS, aX as Day, aA as DayInput, aW as DayInputLegacy, az as DayValue, b1 as DecimalInput, b0 as DecimalValue, dp as DefaultListener, cs as Disposable, cr as Disposer, cq as DisposerFunction, dq as Emitter, dm as EmitterAllHandler, dl as EmitterHandler, du as Encoder, bu as FilterFunction, dw as JsonEncoder, dn as ListenerSignature, dj as LocalChannel, d5 as LogLevel, d6 as LogLevelAlias, d7 as LogLevelAliasKey, b as LogLevelAliasType, d4 as Logger, db as LoggerConsoleHandler, da as LoggerContext, d9 as LoggerContextInterface, c as LoggerInterface, dg as LoggerMemoryHandler, bv as MapperFunction, e4 as MemStorage, e3 as MemStorageOptions, dA as Message, dy as MessageAction, dE as MessageDefinitions, dF as MessageHub, dz as MessageResult, dC as MessagesDefaultMethods, dD as MessagesMethods, dB as MessagesOptions, cB as Mutex, e8 as NestedArray, dv as NoopEncoder, cL as Pool, cH as PoolTask, cJ as PoolTaskEvents, cF as PoolTaskFn, cI as PoolTaskIdConflictResolution, cG as PoolTaskState, bb as Primitive, dI as PubSub, dN as RPCFn, dM as RPCOptions, dO as RPCReturn, au as RenderMessagesOptions, dL as ReturnType, bU as RoundingMode, c_ as SerialQueue, c3 as SortableItem, cZ as TaskEvents, cY as TaskFn, ae as Uint8ArrayToHexDump, ad as Uint8ArrayToJson, a2 as Uint8ArrayToString, cx as UseDefer, cu as UseDispose, cp as XRX, a0 as _decodeUtf8Polyfill, $ as _encodeUtf8Polyfill, M as arrayAvg, N as arrayBatches, y as arrayEmptyInPlace, w as arrayFilterInPlace, q as arrayFlatten, s as arrayIntersection, B as arrayIsEqual, H as arrayMax, I as arrayMin, o as arrayMinus, G as arrayRandomElement, u as arrayRemoveElement, v as arraySetElement, E as arrayShuffle, F as arrayShuffleForce, D as arrayShuffleInPlace, z as arraySorted, A as arraySortedNumbers, K as arraySum, t as arraySymmetricDifference, x as arrayToggleInPlace, p as arrayUnion, n as arrayUnique, bH as avg, bF as between, cj as cloneJsonObject, ci as cloneObject, bQ as cmp, bP as composeOrderby, P as createArray, dk as createLocalChannelPair, cM as createPromise, dG as createPromiseProxy, l as csvParse, m as csvParseToObjects, k as csvStringify, a$ as dateStringToDays, a_ as day, aD as dayDay, aT as dayDiff, aH as dayFromAny, aJ as dayFromDate, aK as dayFromDateGMT, aO as dayFromParts, aP as dayFromString, aM as dayFromTimestamp, aG as dayFromToday, aV as dayIterator, aC as dayMonth, aQ as dayMonthStart, aS as dayOffset, aU as dayRange, aF as dayToDate, aI as dayToDateGMT, aE as dayToParts, aN as dayToString, aL as dayToTimestamp, aB as dayYear, aR as dayYearStart, d0 as debounce, b2 as decimal, b5 as decimalCentsPart, b3 as decimalFromCents, b4 as decimalToCents, U as decodeBase16, R as decodeBase32, W as decodeBase58, Y as decodeBase62, j as decrypt, b6 as deepEqual, b8 as deepMerge, b7 as deepStripUndefinedInPlace, h as deriveKeyPbkdf2, d$ as detect, g as digest, ch as empty, T as encodeBase16, Q as encodeBase32, V as encodeBase58, X as encodeBase62, cb as encodeQuery, i as encrypt, c5 as endSortWeight, cd as ensureKey, ce as ensureKeyAsync, ab as equalBinary, b9 as escapeHTML, bT as escapeRegExp, Z as estimateSizeForBase, dS as fetchBasic, dT as fetchJson, dX as fetchOptionsBasicAuth, dV as fetchOptionsFormURLEncoded, dW as fetchOptionsJson, dU as fetchText, ax as fixBrokenUth8String, aY as forEachDay, cm as forTimes, av as formatMessages, e6 as formatMilliseconds, a9 as fromBase64, aa as fromBase64String, ai as fromCamelCase, a6 as fromHex, d_ as getGlobal, d1 as getGlobalContext, dr as getGlobalEmitter, d3 as getGlobalLogger, dc as getNamespaceFilterString, dZ as getNavigator, bA as getSecureRandom, bB as getSecureRandomIfPossible, e5 as getTimestamp, dY as getWindow, dQ as httpMethod, cO as immediate, be as isArray, bl as isBoolean, e0 as isBrowser, bW as isEven, bV as isHalf, bj as isInteger, d2 as isLocalHost, bp as isNotNull, bn as isNull, bm as isNullOrUndefined, bi as isNumber, bc as isObject, bJ as isPrime, bI as isPrimeRX, bd as isPrimitive, cV as isPromise, bf as isRecord, bg as isRecordPlain, bk as isSafeInteger, bh as isString, cS as isTimeout, bo as isUint8Array, bq as isValue, a4 as joinToUint8Array, bt as jsonStringify, bs as jsonStringifySafe, br as jsonStringifySorted, ac as jsonToUint8Array, cg as last, dt as lazyListener, c9 as linkifyPlainText, by as listDistinctUnion, bx as listGroupBy, bz as listOfKey, bw as listQuery, ck as memoize, cl as memoizeAsync, ds as messages, c6 as moveSortWeight, e9 as noop, bN as objectIsEmpty, bL as objectMap, bM as objectMergeDisposable, dR as parseBasicAuth, e7 as parseDate, de as parseLogLevel, bO as parseOrderby, cc as parseQuery, e1 as platform, cW as promisify, ev as qid, bC as randomBoolean, bE as randomFloat, bD as randomInt, r as randomUint8Array, co as regExpEscape, cn as regExpString, aw as renderMessages, bY as roundDown, b$ as roundHalfAwayFromZero, c0 as roundHalfDown, c1 as roundHalfEven, b_ as roundHalfOdd, c2 as roundHalfTowardsZero, bZ as roundHalfUp, bX as roundUp, bK as seededRandom, ep as setUuidDefaultEncoding, cf as size, cN as sleep, c7 as sortedItems, bR as sortedOrderby, c4 as startSortWeight, aj as stringToBoolean, al as stringToFloat, ak as stringToInteger, a1 as stringToUInt8Array, el as suid, ek as suidBytes, en as suidBytesDate, em as suidDate, bG as sum, c$ as throttle, cQ as timeout, cP as timeoutReached, cR as timoutError, a7 as toBase64, a8 as toBase64Url, at as toBool, af as toCamelCase, ag as toCapitalize, ah as toCapitalizeWords, aq as toFloat, a5 as toHex, ca as toHumanReadableUrl, ar as toInt, as as toString, a3 as toUint8Array, bS as toValidFilename, aZ as today, cT as tryTimeout, eu as uname, ba as unescapeHTML, cE as useAsyncMutex, S as useBase, cw as useDefer, ct as useDispose, cv as useDisposer, cA as useEventListener, e2 as useExitHandler, cz as useInterval, df as useLevelFilter, dH as useMessageHub, cD as useMutex, dd as useNamespaceFilter, cK as usePool, dJ as usePubSub, dP as useRPC, c8 as useSorted, cy as useTimeout, eq as uuid, eo as uuid32bit, ee as uuidB32, eb as uuidB62, ea as uuidBytes, er as uuidDecode, eg as uuidDecodeB32, ed as uuidDecodeB62, ej as uuidDecodeV4, es as uuidEncode, ef as uuidEncodeB32, ec as uuidEncodeB62, ei as uuidEncodeV4, et as uuidIsValid, eh as uuidv4, am as valueToBoolean, ao as valueToFloat, an as valueToInteger, ap as valueToString, cU as waitOn } from './uuid-86fe76bf.js';

interface ParseConfig {
    args?: string[];
    alias?: Record<string, string[]>;
    normalize?: (value: string) => string;
    booleanArgs?: string | string[];
    listArgs?: string | string[];
    numberArgs?: string | string[];
}
declare function parseArgs(config?: ParseConfig): Record<string, any>;

/** Copy string to clipboard */
declare function pbcopy(data: string): Promise<unknown>;

interface csvOptions {
    /** @deprecated will probably be replaced by logLevel */
    debug?: boolean;
    path?: string;
    filename?: string;
    encoding?: BufferEncoding;
    prefix?: string;
    env?: Record<string, string>;
}
/**
 * Return a path relative to the current working directory
 */
declare function stringToPath(value?: string, defaultValue?: string): string;
declare function valueToPath(value?: any, defaultValue?: string): string;
declare const toPath: typeof valueToPath;
declare function getEnvVariableRelaxed(name: string, env?: NodeJS.ProcessEnv): string | undefined;
/** Populates process.env from .env file. */
declare function setupEnv(options?: csvOptions): {
    parsed: Record<string, string>;
    error?: undefined;
} | {
    error: unknown;
    parsed?: undefined;
};

interface FileStorageOptions {
    pretty?: boolean;
    path?: string;
    extension?: string;
    objectFromString?: (data: string) => any;
    objectToString?: (data: any) => string;
    keyToFilename?: (key: string) => string;
}
declare class FileStorage<T = Json> implements ObjectStorage<T> {
    private store;
    private dirname;
    private fileKeys?;
    private pretty;
    private extension;
    private extensionLength;
    private objectFromString;
    private objectToString;
    private keyToFilename;
    constructor(opt?: FileStorageOptions);
    setItem(key: string, value: T): void;
    getPath(key: string): string;
    getBuffer(key: string): Buffer;
    getItem(key: string): T | undefined;
    removeItem(key: string): void;
    clear(): void;
    allKeys(): string[];
}

declare function toHumanReadableFilePath(path: string): string;
declare function exists(path: string): Promise<boolean>;
declare function ensureFolder(...parts: string[]): Promise<string>;
declare function removeFolder(...parts: string[]): Promise<string>;
declare function readText(...parts: string[]): Promise<string | undefined>;
declare function writeText(path: string, content: string): Promise<void>;

declare function LoggerFileHandler(path: string, opt?: LogHandlerOptions): (msg: LogMessage) => void;

declare function colorString(text: string, colorCode: number): string;
declare function colorStringList(list: Array<any>, style: string, bold?: boolean): any[];
declare const loggerStackTraceDebug = "loggerStackTraceDebug-7d38e5a9214b58d29734374cdb9521fd964d7485";
declare function LoggerNodeHandler(opt?: LogHandlerOptions): LogHandler;

declare function getStackLlocationList(stack: string): string[];
/**
 * Get the source code location of the caller
 * https://stackoverflow.com/a/47296370/140927
 *
 * @param level Number of levels to go down the stack trace
 * @param stripCwd Strip the current working directory, only reasonable for Node.js environment
 * @returns
 */
declare function getSourceLocation(level?: number, stripCwd?: boolean): string;
declare function getStack(): string;
declare function getSourceLocationByPrecedingPattern(patterns: string[], stripCwd?: boolean): string;

export { FileStorage, FileStorageOptions, Json, LogHandler, LogHandlerOptions, LogMessage, LoggerFileHandler, LoggerNodeHandler, ObjectStorage, colorString, colorStringList, ensureFolder, exists, getEnvVariableRelaxed, getSourceLocation, getSourceLocationByPrecedingPattern, getStack, getStackLlocationList, loggerStackTraceDebug, parseArgs, pbcopy, readText, removeFolder, setupEnv, stringToPath, toHumanReadableFilePath, toPath, valueToPath, writeText };
